<?php

  get("/", function () {
    view("index");
  });



  get("/member", function () {
    if (@$_SESSION['user']) {
      move("/", "이미 로그인되어 있습니다.");
    }

    view("member");
  });



  post("/login", function () {
    if (!@$_POST['id'] || !@$_POST['pw']) {
      move("/member", "잘못된 접근입니다.");
    }

    if (trim($_POST['id']) === "" || trim($_POST['pw']) === "") {
      move("/member", "아이디나 비밀번호가 비어 있습니다. 다시 확인해 주세요.");
    }


    $user_data = user::find("id = ? && pw = ?", [$_POST['id'], $_POST['pw']]);

    if (!$user_data) move("/member", "아이디나 비밀번호를 잘못 입력했습니다. 다시 확인해 주세요.");
    else {
      $_SESSION['user'] = $user_data;
      move("/", "로그인이 완료되었습니다.");
    }
  });



  get("/logout", function () {
    session_destroy();
    move("/", "로그아웃이 완료되었습니다.");
  });



  get("/list/$", function ($list_type) {
    $list_type = @[
      "cycle" => "전기자전거",
      "small_car" => "미니전기자동차",
      "scooter" => "전기스쿠터",
      "car" => "전기자동차",
      "long_distance_car" => "장거리전기자동차"
    ][$list_type];
    $products = product::findAll("category = ?", $list_type);

    if (!$products) {
      move("back", "잘못된 접근입니다.");
    }

    view("list", ["data" => $products]);
  });



  get("/detail/$", function ($idx) {
    $detail_data = product::find("idx = ?", $idx);
    $detail_images = explode(",", $detail_data['detail']);
    $category = @[
      "전기자전거" => "cycle",
      "미니전기자동차" => "small_car",
      "전기스쿠터" => "scooter",
      "전기자동차" => "car",
      "장거리전기자동차" => "long_distance_car",
    ][$detail_data['category']];

    view("detail", ["data" => $detail_data, "detail_images" => $detail_images, "category" => $category]);
  });



  post("/upload/$", function ($idx) {
    if (!$idx) return move("back", "잘못된 접근입니다.");
    

    $img = @$_FILES['detail-image'];
    if (trim($img['name']) == '') return move("back", "이미지가 없습니다.");
    
    $imgExt = array_reverse(explode(".", $img['name']))[0];
    $imgName = uniqid().trim($img['name']);
    if ($imgExt != "jpg" && $imgExt != "jpeg" && $imgExt != "png") {
      return move("back", "이미지는 .jpg, .jpeg, .png 파일만 업로드할 수 있습니다.");
    }

    $product_data = product::find("idx = ?", $idx);
    if (!$product_data) {
      return move("back", "잘못된 접근입니다.");
    }
    $product_data_details = explode(",", $product_data['detail']);
    $product_data_details[] = $imgName;
    $product_data_details = implode(",", $product_data_details);
    product::update(["detail" => $product_data_details], $idx);

    move_uploaded_file($img['tmp_name'], ROOT."/images/$imgName");
    

    move("back", "이미지를 업로드했습니다.");
  });



  get("/reservation/$", function ($idx) {
    if (!$idx) return move("back", "잘못된 접근입니다.");
    if (!@$_SESSION['user']) return move("/member", "로그인 후 이용해주세요.");
    if ($_SESSION['user']['level'] == "관리자") return move("/", "관리자는 예약할 수 없습니다.");

    $product_data = product::find("idx = ?", $idx);
    
    view("reservation", ["data" => $product_data]);
  });
  
  post("/pay_ready", function () {
    if (!@$_POST['idx']) return move("back", "잘못된 접근입니다.");
    if (!@$_SESSION['user']) return move("/member", "로그인 후 이용해주세요.");
    if ($_SESSION['user']['level'] == "관리자") return move("/", "관리자는 예약할 수 없습니다.");


    $product_data = product::find("idx = ?", $_POST['idx']);
    switch ($product_data['category']) {
      case "전기자동차": 
      case "장거리전기자동차": 
        if (!@$_POST['start'] || !@$_POST['end'] || !@$_POST['stPlace'] || !@$_POST['enPlace'])
          return move("back", "누락된 정보가 있습니다. 다시 확인하여 주세요.");

        if (!preg_match("/\d{4}-\d{2}-\d{2}(?!.)/", $_POST['start'])
         || !preg_match("/\d{4}-\d{2}-\d{2}(?!.)/", $_POST['end'])) {
           return move("back", "날짜 값이 잘못되었습니다. 다시 확인하여 주세요.");
         }

        extract($_POST);
        if (strtotime($start) - strtotime(date("Y-m-d")) < 86400)
          return move("back", "내일부터 대여할 수 있습니다.");
        if (strtotime($end) - strtotime($start) < 86400)
          return move("back", "반납일은 대여일로부터 적어도 하루 뒤어야 합니다.");

        break;
      case "전기자전거":
      case "미니전기자동차":
      case "전기스쿠터":
        if (!@$_POST['stTime'] || !@$_POST['enTime'] || !@$_POST['stPlace'] || !@$_POST['enPlace'])
          return move("back", "누락된 정보가 있습니다. 다시 확인하여 주세요.");

        extract($_POST);
        if (strtotime(date("Y-m-d ".$stTime)) - strtotime(date("Y-m-d H:00")) < 3600)
          return move("back", "다음 시간부터 대여할 수 있습니다.");
        if (strtotime(date("Y-m-d ".$enTime)) - strtotime(date("Y-m-d ".$stTime)) < 3600)
          return move("back", "반납 시간은 대여 시간으로부터 적어도 한 시간 뒤어야 합니다.");
    
        break;
    }


    $data = [];

    $rental_date = @$_POST['start'] 
      ? $_POST['start']." 00:00:00"
      : date("Y-m-d")." ".$_POST['stTime'];
    $return_date = @$_POST['end']
      ? $_POST['end']." 00:00:00"
      : date("Y-m-d")." ".$_POST['enTime'];


    $price = $product_data['price'];
    
    $account_discount = [
      "일반회원" => 5,
      "멤버십회원" => 10,
      "VIP회원" => 15
    ][$_SESSION['user']['level']];
    $data['product_price'] = $price *
      (
        @$_POST['start'] 
          ? (strtotime($end) - strtotime($start)) / 86400
          : (strtotime($enTime) - strtotime($stTime)) / 3600
      );
    $data['discount'] = calculatePrice($price, $rental_date, $return_date);
    $data['account_discount'] = $price * ($account_discount / 100);
    $data['price'] = $data['discount'] - ($price * ($account_discount / 100));

    view("cardPay", ["data" => $product_data, "post" => $_POST, "info" => $data]);
  });



  post("/payment", function () {

    $card_condition = (  
         in_array("농협", array_keys(@$_POST))
      || in_array("하나", array_keys(@$_POST))
      || in_array("신한", array_keys(@$_POST))
      || in_array("국민", array_keys(@$_POST))
      || in_array("우리", array_keys(@$_POST))
      ) && trim(@$_POST['card_no']) !== '';
    $other_condition = (
       trim(@$_POST['bank_target']) !== ''
    && trim(@$_POST['from_name']) !== ''
    && trim(@$_POST['phone']) !== ''
    );

    
    if (!$card_condition && !$other_condition) {
      return move('back', '잘못된 정보를 기입하셨거나, 누락된 정보가 있습니다.');
      exit;
    }

    return move('/mypage', '결제가 완료되었습니다.');
    exit;

    view("payment");
  });



  get("/mypage", function () {
    

    view("mypage");
  });



  get("/rental", function () {
    view("rental");
  });
  get("/cardPay", function () {
    view("cardPay");
  });
  get("/admin", function () {
    view("admin");
  });
  get("/item", function () {
    view("item");
  });
  get("/material", function () {
    view("material");
  });



  function calculatePrice($price, $start, $end) {
    $discount = [];
    $day_discount = [-20, 0, 30, 30, 30, 0, -20];

    
    // DISCOUNT PERCENTAGE SET
    $focused_date = strtotime($start);
    $date_diff = (strtotime($end) - strtotime($start)) / 86400;

    if (date('Y-m-d', strtotime($start)) == date('Y-m-d', strtotime($end))) {
      $date_diff = (strtotime($end) - strtotime($start)) / 3600;
      $discount[] = $day_discount[date('w')];
    } else {
      for ($i = 1; $focused_date !== strtotime($end); $i++) {
        $focused_date = strtotime($start." + $i days");
        dd(date("Y-m-d H:i:s", $focused_date));
        $discount[] = $day_discount[date('w', $focused_date)];
      }
      array_unique($discount);
    }

    if (count($discount) == 3) {
      array_filter($discount, function ($a) {
        return $a !== 0;
      });
    }


    // PERCENTAGE CALCULATE
    $percentage_sum = array_sum($discount);
    $percentage = $percentage_sum /= count($discount);
    $percentage /= 100;

    $price *= $date_diff;
    $price = $price - ($price * $percentage);


    return $price;
  }

?>